var btn = ['确认升级', '取消'];

function appUpdate(ismanual) {
	ismanual = ismanual || false;
	mui.plusReady(function() {
		plus.runtime.getProperty(plus.runtime.appid, function(inf) {
			ver = inf.version;
			var apid = localStorage.getItem('appid');
			var aptype = localStorage.getItem('apptype');
			var url = actionUrl + 'dirVersion.action?appType=' + aptype + '&appId=' + apid +
				'&versionNum=3';
			var ua = navigator.userAgent.toLowerCase();
			if (/iphone|ipad|ipod/.test(ua)) { //苹果手机            
				mui.ajax({
					type: "get",
					dataType: 'json',
					url: "https://itunes.apple.com/cn/lookup?" + Math.random(), //获取当前上架APPStore版本信息
					data: {
						id: 1519792536 //APP唯一标识ID
					},
					contentType: 'application/x-www-form-urlencoded;charset=UTF-8',
					success: function(data) {
						var resultCount = data.resultCount;
						for (var i = 0; i < resultCount; i++) {
							var normItem = data.results[i].version;

							var s = versionSizeComparison_(ver, normItem);

							if (s == -1) {
								//alert("发现新版本");
								var _msg = "发现新版本"
								//plus.nativeUI.alert("发现新版本:V" + normItem);
								mui.confirm(_msg, '升级确认', btn, function(e) {
									if (e.index == 0) { //执行升级操作
										cleanCache(function() {
											document.location.href = 'https://apps.apple.com/cn/app/%E7%B2%A4%E8%8B%97/id1519792536'; //上新APPStore下载地址
										});
									} else {
										// plus.runtime.quit(); // 苹果不允许强制更新
									}
								});
								return;
							} else {
								if (ismanual) {
									mui.toast('当前版本已是最新');
								}
							}
						}
						
						return;
					}
				});
			} else if (/android/.test(ua)) {
				mui.ajax(url, {
					data: {
						apkVersion: ver,
					},
					dataType: 'json',
					type: 'get',
					timeout: 10000,
					success: function(data) {
						if (data.statusCode = 200) {
							var normItem = data.message[0].version
							// console.log(normItem);
							var s = versionSizeComparison_(ver, normItem);
							if (s == -1) {
								var _msg = "发现新版本";
								mui.confirm(_msg, '升级确认', btn, function(e) {
									if (e.index == 0) { //执行升级操作
										//                                  plus.nativeUI.toast("正在准备环境，请稍后！");
										//                                  var dtask = plus.downloader.createDownload(config.apkUrl, {}, function (d, status) {
										//                                      if (status == 200) {
										//                                          var path = d.filename;//下载apk
										//                                          plus.runtime.install(path); // 自动安装apk文件
										//                                      } else {
										//                                          plus.nativeUI.alert('版本更新失败:' + status);
										//                                      }
										//                                  });
										//                                  dtask.start();
										// document.location.href = 'http://m.anzhi.com/share_3130167.html?azfrom=anzhi&host=details&pkg=io.dcloud.H5AC4580F&flag=1&aztype=qr'; //上新APPStore下载地址
										
										cleanCache(function() {
											var url = "market://details?id=plus.H5A84F959";
											
											plus.runtime.openURL(url, function(e) {
												plus.runtime.openURL(url, function(e) {
													plus.runtime.openURL(url, function(e) {
														mui.alert('请自行去应用市场更新APP</br>（除华为应用市场外，其他市场需要2-3天审核期，请耐心等待）', '', '', function (e) {
														   
														},'div')
													}, "com.huawei.appmarket"); //华为应用市场
												}, "cn.goapk.market"); //安智市场  
											}, "com.baidu.appsearch"); //百度助手市场  
										});
									} else {
										// plus.runtime.quit(); // 暂时关闭强制升级，待后续方案定型之后再打开
									}
								});
							} else {
								if (ismanual) {
									mui.toast('当前版本已是最新');
								}
							}
							//mui.toast("发现新版本:V" + data.Data);//获取远程数据库中上新andriod版本号 
						}
					},
					error: function(xhr, type, errerThrown) {
						if (ismanual) {
							mui.toast('网络异常,请稍候再试');
						}
					}
				});
			}
		});
	});
}



function versionSizeComparison_(v1, v2) {
	v1 = v1 || "";
	v2 = v2 || "";
	/**
	 * @value 1 表示大
	 * @value -1 表示小
	 * @value 0 表示相等
	 */
	var comparison = 0
	var v1Arr = v1.split('.')
	var v2Arr = v2.split('.')
	var foreachNum = v1Arr.length < v2Arr.length ? v2Arr.length : v1Arr.length
	for (var i = 0; i < foreachNum; i++) {
		if (!v2Arr[i] || Number(v1Arr[i]) > Number(v2Arr[i])) {
			comparison = 1
			break
		}
		if (!v1Arr[i] || Number(v1Arr[i]) < Number(v2Arr[i])) {
			comparison = -1
			break
		}
	}
	return comparison
}
// 清除缓存
function cleanCache(callback) {
	localStorage.clear();
	sessionStorage.clear();
	if(plus.cache && plus.cache.calculate) {
		if(typeof auths == "undefined") {
			auths = {};
		}
		if (auths && auths.weixin && auths.weixin.authResult ) {
			 auths.weixin.logout(function() {
				 // alert("清除缓存成功");
			 });
		}
		plus.cache.calculate(function(size) {
		    plus.cache.clear && plus.cache.clear(function() {
		        callback && callback();
		    });
		});
	} else {
		localStorage.clear();
		sessionStorage.clear();
		callback && callback();
	}
}